'Option Explicit
On Error Resume Next
Dim WSH ' "WScript.Shell"
Set Bases = CreateObject("Scripting.Dictionary")

'**************************************************************************************************
'  
S7zPath = "C:\Program Files\7-Zip\7z.exe"                     	        '    7z
sqlmaintPath = "C:\Program Files\Microsoft SQL Server\MSSQL\Binn\sqlmaint.exe" 		 '   sqlmaint.exe 

' ,       
servername="1cSQL"					                '   sql
serverlogin ="sa"							              '  sql
serverpass = "gfhjkmSQL"							      '   sql
BackupFolder = "C:\data_\"         '    
' ------------------

'   : DB   sql,    1
Bases.Add "tr1"    ,  		"C:\1cbases\db_1"
Bases.Add "tr2"    ,  		"C:\1cbases\db_2"
' ...
' ...
'   ()
'**************************************************************************************************

Set FSO = CreateObject("Scripting.FileSystemObject")               
'  
if not FSO.FileExists(S7zPath) Then                                        
	MsgBox  "     7z"
	wscript.Quit
end if
if not FSO.FileExists(sqlmaintPath) Then                                        
	MsgBox  "     sqlmaintPath.exe"
	wscript.Quit
end if
if not FSO.FolderExists(BackupFolder) Then                                        
	MsgBox  "     "
	wscript.Quit
end if
' -----------


Set WSH = CreateObject("WScript.Shell")          
DateStamp=GetDateString '  
BackupFolder1= BackupFolder & "\" & DateStamp 
TempPath = FSO.GetSpecialFolder(2)
filelistprm_name = TempPath & "\filelist.prm"          

'    
If not FSO.FolderExists(BackupFolder1) Then
	FSO.CreateFolder(BackupFolder1)
End If

'     
LogPath = BackupFolder1 & "\BackUp1C.log"

' -
if FSO.FileExists(LogPath) Then
	FSO.DeleteFile(LogPath)
end if
Set LogFile = FSO.CreateTextFile(LogPath)

'   
BaseCounter = 0
For Each Base In Bases

  LogFile.WriteLine " : "  & Base 

	Set filelistprm = FSO.CreateTextFile(filelistprm_name)

	'    sqlmaint -  backup  sql        
	runarch=false
	RetCode = WSH.Run ("""" & sqlmaintPath & """ -S " & servername & " -U " & serverlogin & " -P " & serverpass & " -D " & Base &"  -BkUpDB """ & BackupFolder1  & """ -BkUpMedia DISK ", 1, True)
	if RetCode=1 Then
		LogFile.WriteLine "      DB.  sql  ."
  else
    filelistprm.WriteLine BackupFolder1 & "\*.bak"
    runarch=true
	end if
	' ---------------                                                                                              
	
	basepath=Bases.Item(Base)
	if not FSO.FileExists(basepath & "\1Cv7.MD") Then                                        
    LogFile.WriteLine "  1    1cv7.md"
  else
    filelistprm.WriteLine basepath & "\1Cv7.MD"
    runarch=true
  end if
  filelistprm.WriteLine basepath & "\1Cv7.DDS" 
	filelistprm.Close
	
	ArchFile= BackupFolder1  & "\" & Base & ".7z"
	if FSO.FileExists(ArchFile) Then
		FSO.DeleteFile(ArchFile)
	end if
	
	if runarch Then
    WSH.Run S7zPath & " a """ & ArchFile & """ @""" & filelistprm_name &""" -scsWIN ", 1, True         
    ' ---------------	
    
    if FSO.FileExists(ArchFile) Then
      LogFile.WriteLine "  "  & ArchFile  '& " - " & TempPath
      FSO.DeleteFile(BackupFolder1 & "\*.BAK")
      BaseCounter = BaseCounter + 1
    else                                                                           
      LogFile.WriteLine "  "
    end if
  else
    LogFile.WriteLine "    -  "
  end if
    
Next '(   )                                   

if FSO.FileExists(filelistprm_name) Then
	FSO.DeleteFile(filelistprm_name)
end if
                                                                                         
LogFile.WriteLine "  : "  & BaseCounter & "  " & Bases.count
LogFile.Close

' 
SendReport LogPath

'     
Function GetDateString

	if Month(Now) < 10 then 
		mmstr = "0" & CStr(Month(Now))
	else 
		mmstr = Cstr(Month(Now))
	end if

	if Day(Now) < 10 then 
		ddstr = "0" & CStr(Day(Now))
	else
		ddstr = Cstr(Day(Now))
	end if
	
	GetDateString = Cstr(Year(Date)) & mmstr & ddstr
End Function

Function SendReport (FileLogName)
                     
	return
	Set msg = CreateObject("CDO.Message")       
	
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = "smtp.mail.ru" 
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = 25
	
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusername") = "kjuby"
	msg.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendpassword") = "gfhjkm"
	msg.Configuration.Fields.Update

	msg.Subject = "  1: " & Now
	msg.Sender = "kjuby@mail.ru"
	msg.From = "kjuby@mail.ru"
	msg.To = "kjuby@mail.ru"               
	msg.TextBody = " , "
	msg.AddAttachment FileLogName
	msg.Send                                 
	
End Function